<?php

class Pi_fsnw_Menu{

    public $plugin_name;
    public $version;
    public $menu;
    
    function __construct($plugin_name , $version){
        $this->plugin_name = $plugin_name;
        $this->version = $version;
        add_action( 'admin_menu', array($this,'plugin_menu') );
        add_action($this->plugin_name.'_promotion', array($this,'promotion'));

        add_action( 'admin_enqueue_scripts', array($this,'removeConflictCausingScripts'), 1000 );
    }

    function plugin_menu(){
        
        $this->menu = add_menu_page(
            __( 'Free Shipping'),
            __( 'Free Shipping'),
            'manage_options',
            'pisol-fsnw-notification',
            array($this, 'menu_option_page'),
            plugins_url( 'free-shipping-notification-woocommerce/admin/img/pi.svg' ),
            6
        );

        add_action("load-".$this->menu, array($this,"bootstrap_style"));
 
    }

    public function bootstrap_style() {
        
        wp_enqueue_style( $this->plugin_name."_bootstrap", plugin_dir_url( __FILE__ ) . 'css/bootstrap.css', array(), $this->version, 'all' );
        
        wp_enqueue_script( $this->plugin_name, plugin_dir_url( __FILE__ ) . 'js/pisol-fsnw-admin.js', array( 'jquery' ), $this->version, false );
		
        wp_enqueue_script( $this->plugin_name."_quick_save", plugin_dir_url( __FILE__ ) . 'js/pisol-quick-save.js', array('jquery'), $this->version, 'all' );
		
	}

    function menu_option_page(){
        if(function_exists('settings_errors')){
            settings_errors();
        }
        ?>
        <div class="bootstrap-wrapper">
        <div class="container mt-2">
            <div class="row">
                    <div class="col-12">
                        <div class='bg-dark'>
                        <div class="row">
                            <div class="col-12 col-sm-2 py-2">
                                    <a href="https://www.piwebsolution.com/" target="_blank"><img class="img-fluid ml-2" src="<?php echo plugin_dir_url( __FILE__ ); ?>img/pi-web-solution.png"></a>
                            </div>
                            <div class="col-12 col-sm-10 d-flex small text-center pisol-top-menu">
                                <?php do_action($this->plugin_name.'_tab'); ?>
                                <a class=" px-2 text-light d-flex align-items-center  border-left border-right  bg-info " href="https://www.piwebsolution.com/free-shipping-notification-bar-user-guide/" target="_blank">
                                <span class="dashicons dashicons-editor-help"></span> User Guide
                                </a>

                                
                                <a class=" px-2 text-light d-flex align-items-center  border-left border-right  bg-danger " href="http://websitemaintenanceservice.in/freeshipping_bar/" target="_blank">
                                <span class="dashicons dashicons-editor-help"></span> PRO Demo
                                </a>
                            </div>
                        </div>
                        </div>
                    </div>
            </div>
            <div class="row">
                <div class="col-12">
                <div class="bg-light border pl-3 pr-3 pb-3 pt-0">
                    <div class="row">
                        <div class="col">
                        <?php do_action($this->plugin_name.'_tab_content'); ?>
                        </div>
                        <?php do_action($this->plugin_name.'_promotion'); ?>
                    </div>
                </div>
                </div>
            </div>
        </div>
        </div>
        <?php
    }

    function promotion(){
        ?>
            <div class="col-12 col-sm-12 col-md-4 pt-3">
                <div class="bg-dark text-light text-center mb-3">
                    <a href="<?php echo esc_url(PI_FSNW_BUY_URL); ?>" target="_blank">
                        <?php new pisol_promotion('pisol_fsnw_instalation_date'); ?>
                    </a>
                </div>

                <div class="bg-dark p-3 text-light text-center mb-3 pi-shadow promotion-bg">
                <h2 class="text-light h3"><span>Get Pro for<br><h1 class="h1 font-weight-bold text-light my-0"><?php echo esc_html(PI_FSNW_PRICE); ?></h1></h2>
                
                <a class="btn btn-danger btn-sm text-uppercase my-2" href="<?php echo esc_url(PI_FSNW_BUY_URL); ?>" target="_blank">Buy Now !!</a>
                <div class="inside">
                    PRO version offers more features:<br><br>
                    <ul class="text-left pisol-pro-feature-list">
                    
                        <li class="border-top py-2 font-weight-light h6">Pro version allows you to set a <strong class="text-primary">custom message</strong> when the user has purchased a certain amount of product</li>
                        <li class="border-top py-2 font-weight-light h6">If you want you can add the shipping bar using the short-code <strong class="text-primary">[free_shipping_notification]</strong></li>
                        <li class="border-top py-2 font-weight-light h6"><strong class="text-primary">Geolocate customer country</strong> and show free shipping message as per there country shipping zone</li>
                        <li class="border-top py-2 font-weight-light h6">It also allows you to show <strong class="text-primary">how much more he has to purchase</strong> to qualify for the free shipping</li>
                        <li class="border-top py-2 font-weight-light h6">It gives you the option to <strong class="text-primary">translate</strong> the custom message in different languages in the multilingual site</li>
                        <li class="border-top py-2 font-weight-light h6">You can <strong class="text-primary">control where to show</strong> the free shipping notification bar Like showing them only on the product pages or cart page or checkout page</li>
                        <li class="border-top py-2 font-weight-light h6">Option to hide <strong class="text-primary">circular progress</strong></li>
                        <li class="border-top py-2 font-weight-light h6">Show <strong class="text-primary">linear progress</strong> within the top free notification bar</li>
                        <li class="border-top py-2 font-weight-light h6">Disable notification bar for the <strong class="text-primary">mobile device</strong></li>
                        <li class="border-top py-2 font-weight-light h6">Set mobile <strong class="text-primary">device brake</strong> point width</li>
						<li class="border-top py-2 font-weight-light h6">Change the<strong class="text-primary">position</strong> of the circular progress</li>
                        <li class="border-top py-2 font-weight-light h6">You can add a <strong class="text-primary">custom shipping icon</strong> in the top message bar to make it look good</li>
                        <li class="border-top py-2 font-weight-light h6">Pro version can work even without selecting a <strong class="text-primary">default shipping zone</strong></li>
                        <li class="border-top py-2 font-weight-light h6">Fully Compatible with <strong class="text-primary">Price Based on Country for WooCommerce</strong> plugin</li>
                        <li class="border-top py-2 font-weight-light h6">Change <strong class="text-primary">thickness</strong> of the linear progress line</li>
                        <li class="border-top py-2 font-weight-light h6">Control the <strong class="text-primary">color of the progress line</strong> to match your website color</li>
                        <li class="border-top py-2 font-weight-light h6">Show free shipping message as <strong class="text-primary">popup</strong></li>
                        <li class="border-top py-2 font-weight-light h6">Free shipping info Popup will come up as the product is <strong class="text-primary">added, deleted, updated</strong></li>
                        <li class="border-top py-2 font-weight-light h6">Free shipping info can be shown as <strong class="text-primary">Popup or Bar or Both</strong></li>
                        <li class="border-top py-2 font-weight-light h6">Option to <strong class="text-primary">Hide non free shipping method</strong>, when FREE shipping is available</li> 
                        <li class="border-top py-2 font-weight-light h6">Compatible with multi currency switcher <strong class="text-primary"><a class="text-primary" href="https://wordpress.org/plugins/woocommerce-currency-switcher/" target="_blank">WooCommerce Currency Switcher by PluginUs.NET</a></strong></li>
                        <li class="border-top py-2 font-weight-light h6">Compatible with multi currency switcher <strong class="text-primary"><a class="text-primary" href="https://wordpress.org/plugins/woocommerce-product-price-based-on-countries/" target="_blank">Price Based on Country for WooCommerce by Oscar Gare</a></strong></li>
                    </ul>
                    <a class="btn btn-light" href="<?php echo esc_url(PI_FSNW_BUY_URL); ?>" target="_blank">Click to Buy Now</a>
                </div>

            </div>
        <?php
    }

    function isWeekend() {
        return (date('N', strtotime(date('Y/m/d'))) >= 6);
    }

    function removeConflictCausingScripts(){
        if(isset($_GET['page']) && $_GET['page'] == 'pisol-fsnw-notification'){
            /* fixes css conflict with Nasa Core */
            wp_dequeue_style( 'nasa_back_end-css' );
        }
    }
}