<?php

class Pisol_fsnw_Option{

    public $plugin_name;

    private $settings = array();

    private $active_tab;

    private $this_tab = 'default';

    private $tab_name = "Basic setting";

    private $setting_key = 'pi_fsnw_basic_setting';
    
    public $tab;

    function __construct($plugin_name){
        $this->plugin_name = $plugin_name;

        

        add_action('woocommerce_init', array($this, 'initialize'));
        
        $this->tab = sanitize_text_field(filter_input( INPUT_GET, 'tab'));
        $this->active_tab = $this->tab != "" ? $this->tab : 'default';

        if($this->this_tab == $this->active_tab){
            add_action($this->plugin_name.'_tab_content', array($this,'tab_content'));
        }


        add_action($this->plugin_name.'_tab', array($this,'tab'),1);
        
    }

    function initialize(){
        
        if($this->getShippingZones() == false){
            $this->settings = array(  array('field'=>'title', 'class'=> 'bg-light text-dark', 'class_title'=>'text-danger text-center font-weight-light h5', 'label'=>__('You need to have a free shipping class, in at-least one of the shipping zones, Then only you can use this plugin, So please set a Free shipping class first ','pisol-fsnw'), 'type'=>'setting_category')
        );
        }else{
            $this->settings = array(
                array('field'=>'pi_fsnw_enabled', 'label'=>__('Enable Free shipping notification','pisol-fsnw'),'type'=>'switch', 'default'=>1,   'desc'=>__('Enable free shipping notification or disable it','pisol-fsnw')),
                array('field'=>'pi_fsnw_default_shipping_zone', 'label'=>__('Select a default shipping zone','pisol-fsnw'),'type'=>'select',   'desc'=>__('This will only show the shipping zone that has free shipping class enabled with minimum order amount condition set','pisol-fsnw'), 'value'=>$this->getShippingZones()),

                array('field'=>'pi_fsn_enable_shortcode', 'label'=>__('Add notification bar using shortcode [free_shipping_notification]','pisol-fsnw'),'type'=>'switch', 'default'=>0,   'desc'=>__('Add notification bar using short code <strong>[free_shipping_notification]</strong><br>Bar Position option in the design Tab will not work when short code is used','pisol-fsnw'), 'pro'=>true),

                array('field'=>'pi_fsnw_dont_show_notification_till_zone_selected', 'label'=>__('Don\'t show notification till Zone is selected','pisol-fsnw'),'type'=>'switch', 'default'=>0,   'desc'=>__('If this is activated it wont show the notification till the user select a zone, if the selected zone has free sipping then it will show the notification','pisol-fsnw'),'pro'=>true),
                array('field'=>'pi_fsnw_disable_mobile', 'label'=>__('Disable for mobile','pisol-fsnw'),'type'=>'switch', 'default'=>0,   'desc'=>__('Disable notification bar for mobile','pisol-fsnw'),'pro'=>true),
                array('field'=>'pi_fsnw_mobile_breakpoint', 'label'=>__('Mobile breakpoint in PX (pixels)','pisol-fsnw'),'type'=>'number', 'default'=>768, 'min'=>0,  'desc'=>__('Breakpoint with for the mobile devices in pixels','pisol-fsnw'),'pro'=>true),
                array('field'=>'pi_fsnw_close_button', 'label'=>__('Show close option','pisol-fsnw'),'type'=>'switch', 'default'=>1,   'desc'=>__('It will show the close button on the bar','pisol-fsnw')),
                array('field'=>'pi_fsnw_persistent_bar', 'label'=>__('Show the Free shipping bar continues','pisol-fsnw'),'type'=>'switch', 'default'=>0,   'desc'=>__('Free shipping notification bar will be shown continues will not get hidden after some time','pisol-fsnw')),
                array('field'=>'pi_fsnw_how_long_to_show', 'label'=>__('How long to show (unit in seconds)','pisol-fsnw'),'type'=>'number', 'default'=>6,   'desc'=>__('Once page ha loaded, then after this many seconds notification will be shown, This is only applicable when Bar is not set to show continues','pisol-fsnw'), 'min'=>1, 'step'=>1),

                array('field'=>'pi_fsnw_ignore_virtual_product_pro', 'label'=>__('Ignore virtual product from minimum amount for free shipping'),'type'=>'switch', 'default'=>0,   'desc'=>__('Virtual product cost will not be considered for minimum amount needed for free shipping'), 'pro'=>true),

                array('field'=>'pi_fsnw_shipping_icon_img', 'label'=>__('Shipping icon to show in message header','pisol-fsnw'),'type'=>'image', 'desc'=>__('You can add this image in the top bar message using short code {icon}','pisol-fsnw'), 'pro'=>true),

                array('field'=>'title2', 'class'=> 'bg-primary text-light', 'class_title'=>'text-light font-weight-light h6', 'label'=>__("Hide other shipping method when Free shipping is available",'pisol-fsnw'), 'type'=>"setting_category"),
                array('field'=>'pi_fsnw_hide_other_shipping', 'label'=>__('When FREE shipping method available','pisol-fsnw'),'type'=>'select',  'desc'=>__('Hide other shipping option when free shipping is available, this will avoid confusion amount your customer','pisol-fsnw'), 'value'=>array('dont_hide'=>__('Don\'t Hide Other methods','pisol-fsnw'),'hide_all'=>__('Hide all the shipping method which are not FREE','pisol-fsnw'), 'hide_all_exclude_local_pickup'=>__('Show only Local pickup and other FREE shipping method','pisol-fsnw')), 'default'=>'dont_hide', 'pro'=>true),

                array('field'=>'title2', 'class'=> 'bg-primary text-light', 'class_title'=>'text-light font-weight-light h6', 'label'=>__('Circular progress','pisol-fsnw'), 'type'=>"setting_category"),
                array('field'=>'pi_fsnw_circular_progress_enabled', 'label'=>__('Show circular progress bar at footer','pisol-fsnw'),'type'=>'switch', 'default'=>1,   'desc'=>__('Show the circular progress bar at the footer when top bar is closed','pisol-fsnw'), 'pro'=>true),
                array('field'=>'pi_fsnw_circular_progress_image', 'label'=>__('Change image inside circular progress image','pisol-fsnw'),'type'=>'image',    'desc'=>__('Image that is shown inside the circular progress bar','pisol-fsnw'), 'pro'=>true),

                array('field'=>'title2', 'class'=> 'bg-primary text-light', 'class_title'=>'text-light font-weight-light h6', 'label'=>__("Lineal progress line shown below the bar",'pisol-fsnw'), 'type'=>"setting_category"),
                array('field'=>'pi_fsnw_linear_progress_enabled', 'label'=>__('Show linear progress bar','pisol-fsnw'),'type'=>'switch', 'default'=>0,   'desc'=>__('Show the linear progress bar','pisol-fsnw'), 'pro'=>true),
                array('field'=>'pi_fsnw_linear_progress_color', 'label'=>__('Progress line color','pisol-fsnw'),'type'=>'color', 'default'=>"#FF0000",   'desc'=>__(''), 'pro'=>true),
                array('field'=>'pi_fsnw_linear_progress_background_color', 'label'=>__('Progress line background color','pisol-fsnw'),'type'=>'color', 'default'=>'#cccccc',   'desc'=>__('Background color of the linear progress line','pisol-fsnw'), 'pro'=>true),
                array('field'=>'pi_fsnw_progress_bar_thickness', 'label'=>__('Select progress bar thickness','pisol-fsnw'),'type'=>'select',  'desc'=>__(''), 'value'=>array('1'=>'1 px','2'=>'2 px','3'=>'3 px', '4'=>'4 px', '5'=> '5 px', '6' => '6 px', '7' => '7 px', '8' => '8 px', '9' => '9 px', '10'=> '10px'), 'default'=>'6', 'pro'=>true),
            );
        }

        $this->register_settings();

        if(PISOL_FSNW_DELETE_SETTING){
            $this->delete_settings();
        }
    }

    
    function delete_settings(){
        foreach($this->settings as $setting){
            delete_option( $setting['field'] );
        }
    }

    function register_settings(){   

        foreach($this->settings as $setting){
            register_setting( $this->setting_key, $setting['field']);
        }
    
    }

    function tab(){
        ?>
        <a class=" px-2 text-light d-flex align-items-center  border-left border-right  <?php echo esc_attr($this->active_tab == $this->this_tab ? 'bg-primary' : 'bg-secondary'); ?>" href="<?php echo admin_url( 'admin.php?page='.sanitize_text_field($_GET['page']).'&tab='.$this->this_tab ); ?>">
        <span class="dashicons dashicons-admin-home"></span> <?php _e( $this->tab_name); ?> 
        </a>
        <?php
    }

    function tab_content(){
        
       ?>
        <form method="post" action="options.php"  class="pisol-setting-form">
        <?php settings_fields( $this->setting_key ); ?>
        <?php
            foreach($this->settings as $setting){
                new pisol_class_form_fsnw($setting, $this->setting_key);
            }
        ?>
        <input type="submit" class="mt-3 btn btn-primary btn-sm" value="Save Option" />
        </form>
       <?php
    }

    function getShippingZones(){
        $shipping_zones = WC_Shipping_Zones::get_zones( );
        $values = array(0 => "Select Free shipping zone");
        foreach($shipping_zones as $shipping_zone){
            $shipping_zone_id = $shipping_zone['zone_id'];

            if($this->checkFreeShippingAvailable($shipping_zone_id)){
                $shipping_zone_obj = WC_Shipping_Zones::get_zone($shipping_zone_id);
                $values[$shipping_zone_id] = $shipping_zone_obj->get_zone_name();
            }
        }
        if(count($values) == 1){
            return false;
        }
        
        return $values;
    }

    function checkFreeShippingAvailable($shipping_zone_id){
        global $wpdb;
        $wfspb_query = $wpdb->prepare( "SELECT * FROM {$wpdb->prefix}woocommerce_shipping_zone_methods WHERE method_id = %s AND is_enabled = %d AND zone_id = %d ORDER BY method_order ASC", 'free_shipping', 1, $shipping_zone_id );
        $zone_data   = $wpdb->get_results( $wfspb_query, OBJECT );

        if ( empty( $zone_data ) ) {
            return false;
        } else {
            return true;
        }

    }
    
}

