(function ($) {
	'use strict';

	/**
	 * All of the code for your admin-facing JavaScript source
	 * should reside in this file.
	 *
	 * Note: It has been assumed you will write jQuery code here, so the
	 * $ function reference has been prepared for usage within the scope
	 * of this function.
	 *
	 * This enables you to define handlers, for when the DOM is ready:
	 *
	 * $(function() {
	 *
	 * });
	 *
	 * When the window is loaded:
	 *
	 * $( window ).load(function() {
	 *
	 * });
	 *
	 * ...and/or other possibilities.
	 *
	 * Ideally, it is not considered best practise to attach more than a
	 * single DOM-ready or window-load handler for a particular page.
	 * Although scripts in the WordPress core, Plugins and Themes may be
	 * practising this, we should strive to set a better example in our own work.
	 */
	jQuery(function () {



		jQuery("#pi_fsnw_persistent_bar").on("change", function () {
			if (jQuery(this).is(":checked")) {
				controlHowLongToShow(true);
			} else {
				controlHowLongToShow(false);
			}
		});

		jQuery("#pi_fsnw_persistent_bar").trigger('change');
	});


	function controlHowLongToShow(state) {
		if (state) {
			jQuery("#row_pi_fsnw_how_long_to_show").fadeOut();
		} else {
			jQuery("#row_pi_fsnw_how_long_to_show").fadeIn();
		}
	}

})(jQuery);
